﻿Public Class Form1
    ' The Bitmap we display.
    Private Bm As Bitmap = Nothing

    ' The dimensions of the drawing area in world coordinates.
    Private Const WorldWidth As Integer = 100
    Private Const WorldHeight As Integer = 100

    ' The scale.
    Private PictureScale As Single = 1.0

    ' Select normal scale.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cboScale.SelectedIndex = 2
    End Sub

    ' Set the selected scale.
    Private Sub cboScale_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboScale.SelectedIndexChanged
        Select cboScale.SelectedIndex
            Case 0
                SetScale(0.25)
            Case 1
                SetScale(0.5)
            Case 2
                SetScale(1.0)
            Case 3
                SetScale(2.0)
            Case 4
                SetScale(4.0)
            Case 5
                SetScale(8.0)
        End Select
    End Sub

    ' Set the scale and redraw.
    Private Sub SetScale(ByVal picture_scale As Single)
        ' Set the scale.
        PictureScale = picture_scale

        ' Make a Bitmap of the righ size.
        Bm = New Bitmap( _
            CInt(PictureScale * WorldWidth), _
            CInt(PictureScale * WorldHeight))

        ' Make a Graphics object for the Bitmap.
        ' (If you need to use this later, you can give it
        ' class scope so you don't need to make a new one.)
        Using gr As Graphics = Graphics.FromImage(Bm)
            ' Use a white background
            ' (so you can see where the picture is).
            gr.Clear(Color.White)

            ' Draw smoothly.
            gr.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias

            ' Scale.
            gr.ScaleTransform(PictureScale, PictureScale)

            ' Draw the image.
            DrawImage(gr)
        End Using

        ' Display the result.
        picCanvas.Image = Bm
    End Sub

    ' Draw the image in world coordinates.
    Private Sub DrawImage(ByVal gr As Graphics)
        Dim rect As Rectangle

        rect = New Rectangle(10, 10, 80, 80)
        gr.FillEllipse(Brushes.LightGreen, rect)
        gr.DrawEllipse(Pens.Green, rect)

        rect = New Rectangle(40, 40, 20, 30)
        gr.FillEllipse(Brushes.LightBlue, rect)
        gr.DrawEllipse(Pens.Blue, rect)

        rect = New Rectangle(25, 30, 50, 50)
        gr.DrawArc(Pens.Red, rect, 20, 140)

        rect = New Rectangle(25, 25, 15, 20)
        gr.FillEllipse(Brushes.White, rect)
        gr.DrawEllipse(Pens.Black, rect)
        rect = New Rectangle(30, 30, 10, 10)
        gr.FillEllipse(Brushes.Black, rect)

        rect = New Rectangle(60, 25, 15, 20)
        gr.FillEllipse(Brushes.White, rect)
        gr.DrawEllipse(Pens.Black, rect)
        rect = New Rectangle(65, 30, 10, 10)
        gr.FillEllipse(Brushes.Black, rect)
    End Sub
End Class
